Status: Closed

Priority: High

Assignee: René-Luc ReLuc

Category: QGIS Server

Affected QGIS version:3.0.0 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: no timely feedback

Crashes QGIS or corrupts data:No Copied to github as #: 26235

Description

Apparently QGIS Server  supports WFS 1.1.0 as advertised by its getcapabilities, but when requested to getcapabilities for

VERSION=1.1.0 it does no return anything different from the default (which is 1.0).

The result is that QGIS WFS client gets confused and you get inverted axis.

Specifying WFS version 1.1 in the client, does not help while setting it to 1.0 does.

Note that the default setting for WFS is AUTO which also fails.

History

#1 - 2018-03-05 06:47 PM - Alessandro Pasotti

To be more precise: the returned XML is different, what does not change is the SRS specification: according to the specs, it should be

urn:x-ogc:def:crs:EPSG:xxxx instead of EPSG: , a WFS 1.1 server returning EPSG:xxxx is not really expected, and a source of confusion

This confuses the client and it is probably a violation of the specifications (not 100% sure about that).

See also: http://docs.geoserver.org/latest/en/user/services/wfs/basics.html#axis-ordering

#2 - 2018-03-05 07:37 PM - Alessandro Pasotti

Another evidence: getFeature call always return 1.1 format but coordinates are not inverted and epsg code is not URN prefixed.

I believe this is the real problem: when using WFS 1.1 the coordinates should be lat/lon and the srsName should be prefixed with urn:ogc:def:crs:

GeoServer fully respect this and Mapserver does it partially: see http://mapserver.org/ogc/wfs_server.html#axis-orientation-in-wfs-1-1-and-2-0

#3 - 2018-03-06 09:21 AM - Alessandro Pasotti

- Subject changed from WFS 1.1.0 broken in QGIS Server  to WFS 1.1.0 broken by inverted axis in QGIS Server 

Things looks more complicated than it seems,

This email exchange is enlightning:

http://lists.osgeo.org/pipermail/standards/2016-October/000994.html
See also:

https://tools.ietf.org/html/rfc5165

And:

http://www.ogcnetwork.net/axisorder

the bottomline is that we should probably change WFS 1.1.0 getfeature response to:

- use urn: prefixed srsName

- return lat/lon instead of lon/lat in GML

#4 - 2018-03-06 11:48 AM - Giovanni Manghi

- Priority changed from Normal to High

- Affected QGIS version changed from master to 3.1(master)

- Regression? changed from No to Yes

Is this a regression or is also true for 2.*?

#5 - 2018-03-06 11:48 AM - Giovanni Manghi

- Status changed from Open to Feedback

#6 - 2018-03-06 12:04 PM - Alessandro Pasotti

I don't think this applies to 2.x: the server code has changed completely and  AFAIK WFS 1.1 was not supported in 2.x

#7 - 2018-03-10 06:19 PM - Alessandro Pasotti

Some more info about other softwares: https://github.com/deegree/deegree3/wiki/Axis-order-handling

#8 - 2018-03-20 01:40 PM - René-Luc ReLuc

- Assignee set to René-Luc ReLuc

Is the master 3.1 or the release 3.0 affected by this issue  ?

#9 - 2018-03-20 02:03 PM - Alessandro Pasotti

Both.

But you'd better wait for https://github.com/qgis/QGIS/pull/6644 if you want to fix it.

#10 - 2018-03-20 02:56 PM - René-Luc ReLuc

- Affected QGIS version changed from 3.1(master) to 3.0.0

I'm waiting for https://github.com/qgis/QGIS/pull/6644
#11 - 2018-03-21 10:30 AM - Alessandro Pasotti

Merged: let me know if you need help.

#12 - 2018-06-14 11:44 AM - Alessandro Pasotti

Can we close this one?

#13 - 2018-12-27 11:13 AM - Nyall Dawson

- Status changed from Feedback to Closed

- Resolution set to no timely feedback
